'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _tunajs = require('tunajs');

var _tunajs2 = _interopRequireDefault(_tunajs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
/* eslint-disable no-restricted-syntax */


var Phaser = function (_Component) {
  _inherits(Phaser, _Component);

  function Phaser(props, context) {
    _classCallCheck(this, Phaser);

    var _this = _possibleConstructorReturn(this, (Phaser.__proto__ || Object.getPrototypeOf(Phaser)).call(this, props));

    var tuna = new _tunajs2.default(context.audioContext);

    _this.connectNode = new tuna.Phaser({
      rate: props.rate,
      depth: props.depth,
      feedback: props.feedback,
      stereoPhase: props.stereoPhase,
      baseModulationFrequency: props.baseModulationFrequency,
      bypass: props.bypass
    });

    _this.connectNode.connect(context.connectNode);
    return _this;
  }

  _createClass(Phaser, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return _extends({}, this.context, {
        connectNode: this.connectNode
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      for (var prop in nextProps) {
        if (this.connectNode[prop]) {
          this.connectNode[prop] = nextProps[prop];
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.connectNode.disconnect();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'span',
        null,
        this.props.children
      );
    }
  }]);

  return Phaser;
}(_react.Component);

Phaser.propTypes = {
  baseModulationFrequency: _react.PropTypes.number,
  bypass: _react.PropTypes.number,
  children: _react.PropTypes.node,
  depth: _react.PropTypes.number,
  feedback: _react.PropTypes.number,
  rate: _react.PropTypes.number,
  stereoPhase: _react.PropTypes.number
};
Phaser.defaultProps = {
  baseModulationFrequency: 700,
  bypass: 0,
  depth: 0.3,
  feedback: 0.2,
  rate: 1.2,
  stereoPhase: 30
};
Phaser.contextTypes = {
  audioContext: _react.PropTypes.object,
  connectNode: _react.PropTypes.object
};
Phaser.childContextTypes = {
  audioContext: _react.PropTypes.object,
  connectNode: _react.PropTypes.object };
exports.default = Phaser;